## How to Use

#### Get Mocking Info

- **How to get GPS coordinates? (latitude & longitude)**
<br/>
[Google Map](https://www.google.com/maps/)
<br/>
[Baidu Map](http://api.map.baidu.com/lbsapi/getpoint/) (Not compatible with phone browser)
<br/>
[AutoNavi Map](http://lbs.amap.com/console/show/picker) (Only China)
<br/>

- **How to get a base station info?**
<br/>
[OpenCellId](http://opencellid.org/)
<br/>
[Cellocation](http://www.cellocation.com/recell.html)（Only Mainland China）
<br/>

#### GPS Movement Simulation
- Go to `App's` per-app settings page, click `Connect`.
- Select menu `Toggle Overlay` in main page.
- Use joystick overlay to set `moving direction` and `strength` (Use for velocity calculation, 100 for `maximum speed`)
- If the `App` is using `Google location service` to obtain Gps location, you can turn on `Google Service API Support` in `Settings`,
and make the settings in `App's` per-app settings page. Now there is no longer need to set `com.google.android.gms` separately.

#### Problems

- If you use `AutoNavi Map` to select a location in Mainland China, you don't need to turn on `Offset correction` in `Settings`.

- Under normal circumstances，you don't need to turn on GPS. Due to the implementation and possible bugs of the `App` and this module, use `GPS Mocking` alone may fail.
<br/><br/>
- If location mocking failed, please update to the latest version and try the following:
  - Ensure the `App` you want to mock has proper permissions
  - Connect to overlay and click `Update` on the overlay
  - Turn on GPS, and make sure that GPS signal is normal
  - Use `Cell Info Mocking` alone
  - Use both `GPS Mocking` and `Cell Info Mocking`
  - If the `App` uses location SDK, try turn on switch in `Settings` - `Experimental`

#### Feedback

- [GitHub](https://github.com/j2rong/FakeLocation/issues)
<br/><br/>
- Feature suggestions
- Bugs
  - Exception log when FC
  - Steps to reproduce
- Location mocking fail
  - App name, package name, version
  - Location mocking mode (`GPS`, `Cell Info`, `Both`)
- Xposed log
  - Turn on `Settings` - `Verbose log`
  - Restart `App` for logging
  - Open `Xposed Installer` - `Log` ，copy the contents
